/*
 * MosP - Mind Open Source Project         http://www.mosp.jp/
 * Copyright (C) 1987-2009 MIND Co., Ltd.  http://www.e-mind.co.jp/
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
package jp.mosp.payroll.bonus.action;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

// import net.sf.jasperreports.engine.JRException;
// import net.sf.jasperreports.engine.JRExporter;
// import net.sf.jasperreports.engine.JRExporterParameter;
// import net.sf.jasperreports.engine.JasperFillManager;
// import net.sf.jasperreports.engine.JasperPrint;
// import net.sf.jasperreports.engine.data.JRBeanCollectionDataSource;
// import net.sf.jasperreports.engine.export.JRPdfExporter;

//import jp.co.u_nic.base.CalculateAction;
//import jp.co.u_nic.base.UnicVo;
//import jp.co.u_nic.common.dto.UmConfDto;
//import jp.co.u_nic.common.dto.UmStationDto;

import jp.mosp.common.dto.MosPConfDto;
import jp.mosp.payroll.base.PayrollVo;
import jp.mosp.payroll.base.PayrollAction;

import jp.mosp.common.vo.MosPVo;

import jp.mosp.payroll.bonus.dto.BonusDetailDto;

import jp.mosp.payroll.bonus.vo.BonusCalcVo;
import jp.mosp.payroll.bonus.vo.BonusCardVo;


import jp.mosp.payroll.bonus.dao.PdBonusDao;
import jp.mosp.payroll.bonus.dto.PdBonusDto;

import jp.mosp.payroll.bonus.BonusConst;

import jp.mosp.common.common.MospConst;
import jp.mosp.common.common.MospException;
import jp.mosp.common.common.MospUtility;

/**
 * 給与明細出力機能を提供する。<br><br>
 * 給与計算画面から、年月を指定して対象全員分の給与明細を一括出力する。<br>
 * また給与明細画面から、選択社員の選択年月における給与明細を出力する。<br>
 */
public class BonusDetailAction extends PayrollAction {
	
	// コマンド
	private static final String CMD_BONUS_DETAIL_ALL = "P2031";
	private static final String CMD_BONUS_DETAIL_ONE = "P2032";
	
	// テンプレートXMLファイルパス
	private static final String template = "/template/bonusDetail.jasper";
	
	/**
	 * コンストラクタ。<br>
	 * 処理シーケンス発行不要設定を行う。<br>
	 */
	public BonusDetailAction() {
		super();
		setNeedProcSeq(false);
	}
	
	/**
	 * 賞与明細を出力する。<br>
	 */
	public void action() throws Exception {
		// DBコネクション取得
		getConnection();
		// PAYROLL権限確認
		if (cmd.equals(CMD_BONUS_DETAIL_ALL)) {
			// VOの取得
			BonusCalcVo vo = (BonusCalcVo)session.getAttribute(MospConst.ATT_FORMER_VO);
			vo.clearMessage();
			vo.clearErrField();
			vo.initVo(cfg, msg, cmd, aspUser, user);
			// パラメータ取得
			vo.setYearParams(request);
			// 対象年月取得
			Date date = vo.getDate(vo.getPltDetailYear(), vo.getPltDetailMonth(), "1");
			Date payday = vo.getDate(vo.getPltDetailYear(), vo.getPltDetailMonth(), vo.getPltDetailDay());
			// 賞与明細データ作成
			List<BonusDetailDto> list = getBonusDetail(date, payday, null, vo.getPltStationCode(), (PayrollVo)vo);
			// 帳票作成準備
			String fileName = vo.getPltDetailYear () + BonusConst.FILE_NAME_SEPARATOR
							+ vo.getPltDetailMonth() + BonusConst.FILE_NAME_SEPARATOR
							+ vo.getPltDetailDay() + BonusConst.FILE_NAME_SEPARATOR
							+ BonusConst.FILE_BONUS_DETAIL;
			request.setAttribute(MospConst.ATT_FILE_NAME, fileName);
			// 帳票作成及び設定
//			request.setAttribute(MospConst.ATT_FILE_OBJECT, print(
//					cfg.getProperty(MospConst.PPT_APP_DOCBASE) + template, list));
		} else if (cmd.equals(CMD_BONUS_DETAIL_ONE)) {
			// VOの取得
			BonusCardVo vo = new BonusCardVo();
			vo = (BonusCardVo)getStoredVo(vo.getClassName());
			vo.clearMessage();
			vo.clearErrField();
			vo.initVo(cfg, msg, cmd, aspUser, user);
			// パラメータ取得
			vo.setParams(request);
			// 対象年月取得
			Date date = vo.getDate(vo.getPltYear(), vo.getPltMonth(), "1");
			Date payday = vo.getDate(vo.getPltYear(), vo.getPltMonth(), vo.getPltDay());
			// 賞与明細データ作成
			List<BonusDetailDto> list = getBonusDetail(date, payday, vo.getHidKCode(), (String)null, (PayrollVo)vo);
			// 帳票作成準備
			String fileName = vo.getPltYear () + BonusConst.FILE_NAME_SEPARATOR
							+ vo.getPltMonth() + BonusConst.FILE_NAME_SEPARATOR
							+ vo.getPltDay() + BonusConst.FILE_NAME_SEPARATOR
							+ vo.getHidKCode()       + BonusConst.FILE_NAME_SEPARATOR
							+ BonusConst.FILE_BONUS_DETAIL;
			request.setAttribute(MospConst.ATT_FILE_NAME, fileName);
			// 帳票作成及び設定
//		request.setAttribute(MospConst.ATT_FILE_OBJECT, print(
//					cfg.getProperty(MospConst.PPT_APP_DOCBASE) + template, list));
		} else {
			throw new MospException(MospConst.EX_CMD_INVALID);
		}
	}
	
	/**
	 * 賞与明細データを作成する。<br>
	 * @param targetMonth 作成対象年月
	 * @param kCode       作成対象社員コード(nullなら全件)
	 * @param vo          VO
	 * @return 賞与明細データリスト
	 * @throws Exception
	 */
	private List<BonusDetailDto> getBonusDetail(
			Date targetMonth, Date payday, String kCode, String stationCode, PayrollVo vo
	) throws Exception {
		// 賞与データ取得準備
		PdBonusDao dao = new PdBonusDao();
		dao.initDao(cfg, cmd, aspUser, user, conn);
		confirmPayrollAuth();
		// 和暦設定取得
		List<MosPConfDto> listConf = getConfList (BonusConst.CONF_ID_JP_IMP_CAL);
		String[][]      aryEra   = getCodeArray(BonusConst.TID_JAPANESE      );
		// 表示用年月取得(対象年月+1)
//		String strDate[] = vo.getJpImperialCal(listConf, targetMonth);
//		strDate[0]       = getCodeName(strDate[0], aryEra);
		// 賞与データ取得
		List<PdBonusDto> listBonus = dao.findForOutputDetail(targetMonth, payday , kCode, stationCode);
		// 賞与明細データ作成
		List<BonusDetailDto> list = new ArrayList<BonusDetailDto>();

		/**
		// 所属マップ取得
		Map<String, PmStationDto> mapStation = getStationMap();
		for (Iterator<PdBonusDto> it = listBonus.iterator(); it.hasNext();) {
			PdBonusDto = it.next();
			BonusDetailDto dto = new BonusDetailDto(PdBonusDto, getMapBonusDetail());
			dto.setYear(strDate[0] + strDate[1]);
			dto.setMonth(strDate[2]);
			// 営業所コード設定
			PmStationDto PmStationDto = mapStation.get(PdBonusDto.getStationCode());
			// 上位コード取得
			dto.setBelongCode(PmStationDto.getBelongCode());
			list.add(dto);
		}
		// 賞与データ確認
		if (list.size() == 0) {
			setVo(vo);
			setUrl(vo.getRetUrl());
			String errMessage = MospUtility.getMessage(msg, BonusConst.MSG_NO_BONUS_DETAIL, "");
			addErrMessage(errMessage);
			throw new MospException(BonusConst.EX_NO_PAYMENT_DETAIL, errMessage);
		}
		
		// 比較クラス
		Comparator<BonusDetailDto> comp = new Comparator<BonusDetailDto>() {
			public int compare(BonusDetailDto obj0, BonusDetailDto obj1) {
				String st1 = obj0.getBelongCode();
				String st2 = obj1.getBelongCode();
				return st1.compareTo(st2);
			}
		};
		// ソート
		Collections.sort(list, comp); // 配列をソート

		
*/
		return list;
	}
}
	
	/**
	 * PDF帳票を作成する。<br>
	 * @param template テンプレートファイルパス
	 * @param list     出力対象リスト
	 * @return PDF出力オブジェクト
	 * @throws MospException
	 */
/**
	private JRExporter print(
			String template, List<BonusDetailDto> list
	) throws MospException {
		try {
			// 動的バインドデータ準備
			JRBeanCollectionDataSource ds = new JRBeanCollectionDataSource(list);
			// 帳票作成
			JasperPrint print = JasperFillManager.fillReport(template, new HashMap(), ds);
			// PDF出力準備
			JRPdfExporter exporter = new JRPdfExporter();
			exporter.setParameter(JRExporterParameter.JASPER_PRINT, print);
			return exporter;
		} catch (JRException e) {
			throw new MospException(BonusConst.EX_PRINT_FAILED, MospUtility.getStackTrace(e));
		}
	}
}
*/
